/*
Copyright The KubeVirt Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha2

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
	v1alpha2 "kubevirt.io/api/instancetype/v1alpha2"
	scheme "kubevirt.io/client-go/kubevirt/scheme"
)

// VirtualMachineClusterInstancetypesGetter has a method to return a VirtualMachineClusterInstancetypeInterface.
// A group's client should implement this interface.
type VirtualMachineClusterInstancetypesGetter interface {
	VirtualMachineClusterInstancetypes() VirtualMachineClusterInstancetypeInterface
}

// VirtualMachineClusterInstancetypeInterface has methods to work with VirtualMachineClusterInstancetype resources.
type VirtualMachineClusterInstancetypeInterface interface {
	Create(ctx context.Context, virtualMachineClusterInstancetype *v1alpha2.VirtualMachineClusterInstancetype, opts v1.CreateOptions) (*v1alpha2.VirtualMachineClusterInstancetype, error)
	Update(ctx context.Context, virtualMachineClusterInstancetype *v1alpha2.VirtualMachineClusterInstancetype, opts v1.UpdateOptions) (*v1alpha2.VirtualMachineClusterInstancetype, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha2.VirtualMachineClusterInstancetype, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha2.VirtualMachineClusterInstancetypeList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha2.VirtualMachineClusterInstancetype, err error)
	VirtualMachineClusterInstancetypeExpansion
}

// virtualMachineClusterInstancetypes implements VirtualMachineClusterInstancetypeInterface
type virtualMachineClusterInstancetypes struct {
	*gentype.ClientWithList[*v1alpha2.VirtualMachineClusterInstancetype, *v1alpha2.VirtualMachineClusterInstancetypeList]
}

// newVirtualMachineClusterInstancetypes returns a VirtualMachineClusterInstancetypes
func newVirtualMachineClusterInstancetypes(c *InstancetypeV1alpha2Client) *virtualMachineClusterInstancetypes {
	return &virtualMachineClusterInstancetypes{
		gentype.NewClientWithList[*v1alpha2.VirtualMachineClusterInstancetype, *v1alpha2.VirtualMachineClusterInstancetypeList](
			"virtualmachineclusterinstancetypes",
			c.RESTClient(),
			scheme.ParameterCodec,
			"",
			func() *v1alpha2.VirtualMachineClusterInstancetype {
				return &v1alpha2.VirtualMachineClusterInstancetype{}
			},
			func() *v1alpha2.VirtualMachineClusterInstancetypeList {
				return &v1alpha2.VirtualMachineClusterInstancetypeList{}
			}),
	}
}
